#include "../../object.h"

static struct json_enum ap_signature_type_enum[] = {
	{ "RsaSignature2017", 1 },
	{ NULL, 0 },
};

#define OBJ_TYPE struct ap_signature
struct json_object_field ap_signature_layout[] = {
	JSON_FIELD_ENUM( type, ap_signature_type_enum, true ),
	JSON_FIELD_STRING( creator, true ),
	JSON_FIELD_DATETIME( created, true ),
	{
		.key = "signatureValue",
		.offset = offsetof( OBJ_TYPE, value ),
		.required = true,
		.type = &json_field_string
	},
	JSON_FIELD_END,
};
#undef OBJ_TYPE

JSON_FIELD_TYPE_COMPOSITE( ap_signature );

